'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TYPES = ['text', 'email', 'password', 'radio', 'checkbox'];

var Input = function (_React$Component) {
    _inherits(Input, _React$Component);

    function Input(props) {
        _classCallCheck(this, Input);

        var state = {};
        state.value = props.value;

        if (props.type == 'radio' || props.type == 'checkbox') state.checked = props.checked;

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Input).call(this, props));

        _this._onMouseEnter = _this._onMouseEnter.bind(_this);
        _this._onMouseLeave = _this._onMouseLeave.bind(_this);
        _this._onChange = _this._onChange.bind(_this);

        _this.state = state;
        return _this;
    }

    _createClass(Input, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (!(this._isRadioButton() || this._isCheckbox()) && this.state.value != prevState.value || (this._isRadioButton() || this._isCheckbox()) && this.state.checked != prevState.checked) {
                this.props.changeCallback();
            }
        }
    }, {
        key: '_onChange',
        value: function _onChange(e) {
            var value = e.target.value;
            var checked = e.target.checked;

            if (this._isRadioButton() || this._isCheckbox()) {
                if (checked == this.state.checked) return;
            } else {
                if (value == this.state.value) return;
            }

            this.setState({
                value: value,
                checked: checked
            });
        }
    }, {
        key: '_isRadioButton',
        value: function _isRadioButton() {
            return this.props.type == 'radio';
        }
    }, {
        key: '_isCheckbox',
        value: function _isCheckbox() {
            return this.props.type == 'checkbox';
        }
    }, {
        key: '_onMouseEnter',
        value: function _onMouseEnter(e) {
            this.props.mouseEnterCallback();
        }
    }, {
        key: '_onMouseLeave',
        value: function _onMouseLeave(e) {
            this.props.mouseLeaveCallback();
        }
    }, {
        key: 'value',
        value: function value(v) {
            if (typeof v === 'undefined') {
                return this.state.value;
            } else {
                this.setState({ value: v });
            }
        }
    }, {
        key: 'checked',
        value: function checked(v) {
            if (!(this._isRadioButton() || this._isCheckbox())) throw new Error("Input type '" + this.props.type + "' doesn't support 'checked'");

            if (typeof v === 'undefined') {
                return this.state.checked;
            } else {
                this.setState({ checked: v });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = (this.props.validate ? "validate " : "") + this.props.extraClass;

            return _react2.default.createElement('input', { placeholder: this.props.placeholder,
                id: this.props.id,
                type: this.props.type,
                disabled: this.props.disabled,
                required: this.props.required,
                name: this.props.name,
                onChange: this._onChange,
                onMouseEnter: this._onMouseEnter,
                onMouseLeave: this._onMouseLeave,
                className: classes });
        }
    }]);

    return Input;
}(_react2.default.Component);

exports.default = Input;


Input.displayName = "GenericInputElement";
Input.propTypes = {
    disabled: _react2.default.PropTypes.bool,
    required: _react2.default.PropTypes.bool,
    validate: _react2.default.PropTypes.bool,
    value: _react2.default.PropTypes.string,
    name: _react2.default.PropTypes.string,
    placeholder: _react2.default.PropTypes.string,
    id: _react2.default.PropTypes.string,
    type: _react2.default.PropTypes.oneOf(TYPES),
    extraClass: _react2.default.PropTypes.string,
    changeCallback: _react2.default.PropTypes.func,
    mouseEnterCallback: _react2.default.PropTypes.func,
    mouseLeaveCallback: _react2.default.PropTypes.func
};
Input.defaultProps = {
    disabled: false,
    required: false,
    validate: false,
    value: '',
    name: '',
    placeholder: '',
    id: '',
    type: 'text',
    extraClass: '',
    changeCallback: function changeCallback() {},
    mouseEnterCallback: function mouseEnterCallback() {},
    mouseLeaveCallback: function mouseLeaveCallback() {}
};